# ../addons/eventscripts/superdice/superdice.py
##########################
#~~~~~~~Super~Dice~~~~~~~#
#~~~~~~~~~By~MiB~~~~~~~~~#
##########################

#################
#~~~~Imports~~~~#
#################
import es # EventScripts Libary
import random # Random Libary
import cmdlib # Command Libary
import popuplib # Popup Libary
import gamethread # Gamethread Libary
import weaponlib # Weapon Libary
import usermsg # User Message Libary
import effectlib # Effect Libary
import psyco # Psyco Libary
psyco.full() # Execute Psyco

################
#~~Addon~Info~~#
################
info = es.AddonInfo() # Gets the information dictionary.
info["name"] = "Super Dice" # Sets addon name.
info["basename"] = "superdice" # Sets addon basefile name.
info["version"] = "0.7.1" # Sets addon version.
info["authors"] = "MiB" # Sets addon author.
info["url"] = "http://www.warcraft-source.com" # Sets author's and/or addon's url.
info["description"] = "The best dice mod!" # Sets addon description.

#################
#~~~Variables~~~#
#################
tick = 0 # Sets tick to zero.
blocks = {} # Creates blocks dictionary.
players = {} # Creates players dictionary.
# Creates primary weapons list.
primarys = ["m3","xm1014","mac10","tmp","mp5navy","ump45","p90","galil","famas","ak47","m4a1","scout","sg550","aug","awp","g3sg1","sg552","m249"]
secondarys = ["glock","usp","p228","deagle","elite","fiveseven"] # Creates secondary weapons list.
ccommands = ["rtd","!rtd","superdice","!superdice","rollthedice","!rollthedice"] # Creates command list.
hcommands = ["rtdhelp","!rtdhelp","superdicehelp","!superdicehelp"] # Creates help command list.
# Creates preset player vars list.
playervars = ["inf","lust","roll","berserker","feeble","highjump","longjump","sunglasses","deadman","heavy","beacon","lasers","drug","tunnel"]
blist = ["c4","nvg","suit","knife","elite","flashbang","hegrenade","smokegrenade"] # Creates berserker non restrict list.
# Creates server variables list.
variables = ["lasermodel","rollinfo","drugoverlay","beaconmodel","gamblelose","gamblechance","gamblewin","berserkertime","tickrate","menusound","rolltime","rollsound","rollchanceshout","infmod","heavymax","heavymin","rollchance","shout","healthmod","superhealthmod","cursemod","tmp","tmp1","tmp2","timemod","lustmod","diceymin","diceymax","armormod","berserkerspeed","berserkerclip","berserkerhealth","illusionalpha","feeblemod","badeyesmin","badeyesmax","badeyesdur","weightsmod","superdiceblock","superdicehelpblock","aeromod","acromod","tmp3"]
for var in variables: es.ServerVar("superdice_%s"%var).set(0) # Sets its variable in the server variables list to zero.
maindir = "addons/eventscripts/superdice" # Creates the main directory of the superdice addons variable.
configdir = "cfg/eventscripts/superdice" # Creates the config directory of the superdice configs variable.
events = "%s/superdice.res"%maindir # Creates the events file location variable.
config = "../%s/superdice.cfg"%configdir # Creates the main config file location variable.

#################
#~~Script~Load~~#
#################
def load():
        es.doblock("corelib/noisy_on") # Adds one to the eventscripts_noisy variable.
        es.load("superdice/superdiceblocks") # Loads the Super Dice blocks script.
        #~~Command~Creation~~#
        cmdlib.registerServerCommand("superdice_addblock",AddBlock,"Adds a block to Super Dice's blocks list. | superdice_addblock <blockname> <rollname> <rolldesc>",skipcheck=True)
	cmdlib.registerServerCommand("superdice_removeblock",RemoveBlock,"Removes a block from Super Dice's blocks list. | superdice_removeblock <block name>",skipcheck=True)
	cmdlib.registerServerCommand("superdice_clearblocks",ClearBlocks,"Clears the blocks from Super Dice's blocks list. | superdice_clearblocks",skipcheck=True)
	cmdlib.registerServerCommand("superdice_reloadblocks",ReloadBlocks,"Reloads Super Dice's superdiceblocks script. | superdice_reloadblocks",skipcheck=True)
	cmdlib.registerServerCommand("superdice_reloadconfig",ReloadConfig,"Reloads Super Dice's config. | superdice_reloadconfig",skipcheck=True)
	cmdlib.registerServerCommand("superdice_createhelp",CreateHelp,"Creates the help popup. | superdice_createhelp",skipcheck=True)
	cmdlib.registerServerCommand("superdice_playerdata",PlayerData,"Lets you set/get/check Super Dice's playerdata. | superdice_playerdata <set/get/check> <userid> <dataname> <setting/return var/return var>",skipcheck=True)
	cmdlib.registerServerCommand("superdice_randomblind",RandomBlind,"Lets start a random delayed blinding on a player. | superdice_randomblind <userid> <min time> <max time> <blind time>",skipcheck=True)
	cmdlib.registerServerCommand("superdice_respawn",Respawn,"Respawns a player. | superdice_respawn <userid>",skipcheck=True)
	cmdlib.registerServerCommand("superdice_damage",Damage,"Damages a player. | superdice_damage <attacker> <victim> <damage>",skipcheck=True)
	cmdlib.registerServerCommand("superdice_randomlist",RandomList,"Gets a random list item. | superdice_randomlist <list> <return var>",skipcheck=True)
	es.mexec(config) # Executes the config file.
	es.addons.registerTickListener(tickcallback) # Creates the tick listener.
        es.loadevents("declare",events) # Declares the events.
	es.loadevents(events) # Loads the events.
        es.addons.registerSayFilter(chatcommands) # Creates the say filter.
        roundchange(0) # Changes the roundend variable to zero.
        gamethread.delayed(0.1,downloads,()) # Declares the downloads.
	es.ServerVar("superdice_version").set(info["version"]) # Sets the public cvar.
	es.ServerVar("superdice_version").makepublic() # Makes the cvar public.

###################
#~~Script~Unload~~#
###################
def unload():
        es.doblock("corelib/noisy_off") # Subtracts one from eventscripts_noisy variable.
        es.unload("superdice/superdiceblocks") # Unloads the Super Dice blocks script.
        #~~Command~Deletion~~#
	cmdlib.unregisterServerCommand("superdice_addblock")
	cmdlib.unregisterServerCommand("superdice_removeblock")
	cmdlib.unregisterServerCommand("superdice_clearblocks")
	cmdlib.unregisterServerCommand("superdice_reloadblocks")
	cmdlib.unregisterServerCommand("superdice_reloadconfig")
	cmdlib.unregisterServerCommand("superdice_createhelp")
	cmdlib.unregisterServerCommand("superdice_playerdata")
	cmdlib.unregisterServerCommand("superdice_randomblind")
	cmdlib.unregisterServerCommand("superdice_respawn")
	cmdlib.unregisterServerCommand("superdice_damage")
	cmdlib.unregisterServerCommand("superdice_randomlist")
	es.addons.unregisterTickListener(tickcallback) # Deletes the tick listener.
	es.addons.unregisterSayFilter(chatcommands) # Deletes the say filter.

###############
#~~Map~Start~~#
###############
def es_map_start(ev):
	es.loadevents(events) # Loads the events.
	roundchange(0) # Changes the roundend variable to zero.
        players = {} # Resets the players dictionary.
        stoprepeat() # Stops any ongoing repeats.
        downloads() # Declares the downloads.

#####################
#~~~Tick~Callback~~~#
#####################
def tickcallback():
        global tick # Globalizes the tick variable.
        tick += 1 # Adds one to the tick variable.
        if tick == int(es.ServerVar("superdice_tickrate")): # Checks if the tick variable equals superdice_tickrate variable.
                tick = 0 # Resets the tick variable.
                for userid in es.getUseridList(): # Finds userids in a userid list.
                        if es.exists("userid",userid): # Checks to see if the userid is in the server.
                                if es.getplayersteamid(userid) != "BOT": # Makes sure the userid isn't a bot.
                                        userid = str(userid) # Converts userid to a string.
                                        if userid in players: # Checks to see if the userid is in the players dictionary.
                                                if str(players[userid]["beacon"]).isdigit(): # Makes sure beacon playervar is a number.
                                                        if int(players[userid]["beacon"]) == 1: # Checks to see if its one.
                                                                __beacon(userid) # Creates a beacon.
                                                if str(players[userid]["tunnel"]).isdigit(): # Makes sure tunnel playervar is a number.
                                                        if int(players[userid]["tunnel"]) == 1: # Checks to see if its one.
                                                                __tunnel(userid) # Sets player's FOV.
                                                if str(players[userid]["drug"]).isdigit(): # Makes sure drug playervar is a number.
                                                        if int(players[userid]["drug"]) == 1: # Checks to see if its one.
                                                                __overlay(userid,es.ServerVar("superdice_drugoverlay")) # Sends the drugging overlay to player.
                                                if str(players[userid]["deadman"]).isdigit(): # Makes sure deadman playervar is a number.
                                                        if int(players[userid]["deadman"]) == 1: # Checks to see if its one.
                                                                __overlay(userid,"superdice/deadman.vmt") # Sends the Dead Man's Curse overlay to player.

#~~Next~release~will~contain~more~help~facts~~#
def __beacon(userid):
        if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 0:
                if es.getplayerteam(userid) == 3:
                        r = 0
                        b = 255
                else:
                        r = 255
                        b = 0
                x,y,z = es.getplayerlocation(userid)
                effectlib.drawCircle((x,y,z + 30),radius=100,steps=12,halo=es.ServerVar("superdice_beaconmodel"),model=es.ServerVar("superdice_beaconmodel"),seconds=0.1,width=20,endwidth=20,red=r,green=50,blue=b)
                effectlib.drawLine((x,y,z),(x,y,z + 99999),halo=es.ServerVar("superdice_beaconmodel"),model=es.ServerVar("superdice_beaconmodel"),seconds=0.1,width=20,endwidth=20,red=r,green=50,blue=b)

def __tunnel(userid):
        if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 0:
                es.setplayerprop(userid,"CCSPlayer.baseclass.m_iFOV",150)

def __overlay(userid,overlay):
        if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 0:
                es.cexec(userid,"r_screenoverlay %s"%overlay)

def downloads():
        es.stringtable("downloadables","sound/%s"%es.ServerVar("superdice_rollsound"))
        es.stringtable("downloadables","sound/%s"%es.ServerVar("superdice_menusound"))
        es.stringtable("downloadables","materials/superdice/deadman.vmt")
        es.stringtable("downloadables","materials/superdice/deadman.vtf")

def popup_create():
        global superdice_help
        superdice_help = popuplib.easymenu("superdice_help",None,superdice_help)
        superdice_help.settitle("SuperDice Help Menu")
        for block in blocks: superdice_help.addoption(block,"%s - %s"%(blocks[block]["name"],blocks[block]["desc"]))

def check_player(userid):
        userid = str(userid)
        if userid not in players:
                players[userid] = {}
                for var in playervars: players[userid][var] = 0

def superdice_help(userid,choice,popupname):
        es.playsound(userid,es.ServerVar("superdice_menusound"),1.0)
        es.tell(userid,"#multi","\x05%s: %s"%(blocks[choice]["name"],blocks[choice]["desc"]))
        superdice_help.send(userid)

def stoprepeat():
        gamethread.cancelDelayed("blind")
	gamethread.cancelDelayed("roundstart")

def roundchange(change):
        global roundend
        roundend = change

def AddBlock(args):
	if len(args) == 3:
		if args[0] not in blocks:
			blocks[args[0]] = {}
			blocks[args[0]]["name"] = args[1]
                        blocks[args[0]]["desc"] = args[2]
                        es.dbgmsg(0,"<addblock> Block was added. <%s - %s - %s>"%(args[0],args[1],args[2]))
		else: es.dbgmsg(0,"<addblock> You supplied a name thats already added. <%s>"%block)
	else: es.dbgmsg(0,"<addblock> You supplied more or less than three arguments.")

def RemoveBlock(args):
	if len(args) == 1:
		if args[0] in blocks:
			del blocks[args[0]]
			es.dbgmsg(0,"<removeblock> Block was removed. <%s>"%args[0])
		else: es.dbgmsg(0,"<removeblock> You supplied a name thats not added. <%s>"%block)
	else: es.dbgmsg(0,"<removeblock> You supplied more or less than one argument.")

def ClearBlocks(args):
	if len(blocks) > 0:
		blocks = {}
	else: es.dbgmsg(0,"<clearblocks> The blocks list is empty.")

def ReloadBlocks(args):
	es.reload("superdice/superdiceblocks")
	es.dbgmsg(0,"<reloadblocks> Blocks reloaded.")

def ReloadConfig(args):
        es.mexec(config)
	es.dbgmsg(0,"<reloadconfig> Config reloaded.")

def CreateHelp(args):
        popup_create()
        es.dbgmsg(0,"<createhelp> Help Menu created.")

def PlayerData(args):
        if len(args) == 4:
                if es.exists("userid",args[1]):
                        userid = str(args[1])
                        if userid not in players: check_player(userid)
                        if args[0] == "set":
                                players[userid][args[2]] = args[3]
                        elif args[0] == "get":
                                if args[2] in players[userid]: es.ServerVar(args[3]).set(players[userid][args[2]])
                                else: es.dbgmsg(0,"<playerdata> Sorry, but it seems that the dataname you supplied does not exist, so can not get your requested data.")
                        elif args[0] == "check":
                                if args[2] in players[userid]: es.ServerVar(args[3]).set(1)
                                else: es.ServerVar(args[3]).set(0)
                        else: es.dbgmsg(0,"<playerdata> Argument one is not set,get, or check, please check your coding.")
                else: es.dbgmsg(0,"<playerdata> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<playerdata> You supplied more or less than four arguments.")

def RandomBlind(args):
        if len(args) == 4:
                if es.exists("userid",args[0]):
                        if es.getplayerprop(args[0],"CCSPlayer.baseclass.pl.deadflag") == 0:
                                __randomblind(args[0],int(args[1]),int(args[2]),float(args[3]))
                        else: es.dbgmsg(0,"<randomblind> The userid you supplied is dead.")
                else: es.dbgmsg(0,"<randomblind> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<randomblind> You supplied more or less than 4 arguments.")

def __randomblind(userid,rbmin,rbmax,rbtime):
        if es.exists("userid",userid):
                if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 0:
                        usermsg.fade(userid,2,(rbtime * float(100)),(rbtime * float(100)),0,0,0,255)
                        delay = random.randint(rbmin,rbmax)
                        gamethread.delayedname(delay,"blind",__randomblind,(userid,rbmin,rbmax,rbtime))

def Respawn(args):
        if len(args) == 1:
                if es.exists("userid",args[0]):
                        if es.getplayerprop(args[0],"CCSPlayer.baseclass.pl.deadflag") == 1:
                                __respawn(args[0])
                        else: es.dbgmsg(0,"<respawn> The userid you supplied is alive.")
                else: es.dbgmsg(0,"<respawn> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<respawn> You supplied more or less than 1 argument.")

def __respawn(userid):
        if es.exists("userid",userid):
                if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 1:
                        es.setplayerprop(userid,"CCSPlayer.m_iPlayerState",0)
                        es.setplayerprop(userid,"CCSPlayer.baseclass.m_lifeState",512)
                        es.server.queuecmd("es_xspawnplayer %s"%userid)

def Damage(args):
        if len(args) == 3:
                if es.exists("userid",args[0]) and es.exists("userid",args[1]):
                        if es.getplayerprop(args[1],"CCSPlayer.baseclass.pl.deadflag") == 0:
                                __damage(args[0],args[1],args[2])
                        else: es.dbgmsg(0,"<damage> The victim you supplied is dead.")
                else: es.dbgmsg(0,"<damage> The attacker or victim you supplied is not on the server.")
        else: es.dbgmsg(0,"<damage> You supplied more or less than 3 arguments.")

def __damage(userid,victim,damage):
        if es.exists("userid",userid) and es.exists("userid",victim):
                if es.getplayerprop(victim,"CCSPlayer.baseclass.pl.deadflag") == 0:
                        es.server.queuecmd("es_xgive %s point_hurt"%victim)
                        es.server.queuecmd('es_xfire %s !self addoutput "targetname superdicevictim"'%victim)
                        es.server.queuecmd('es_xfire %s point_hurt addoutput "targetname superdicedamage"'%victim)
                        es.server.queuecmd('es_xfire %s superdicedamage addoutput "Damage %s"'%(victim,damage))
                        es.server.queuecmd('es_xfire %s superdicedamage addoutput "DamageType 1"'%victim)
                        es.server.queuecmd('es_xfire %s superdicedamage addoutput "DamageTarget superdicevictim"'%userid)
                        es.server.queuecmd("es_xfire %s superdicedamage TurnOn"%victim)
                        es.server.queuecmd("es_xfire %s superdicedamage Hurt"%userid)
                        es.server.queuecmd("es_xfire %s superdicedamage kill"%victim)
                        es.server.queuecmd('es_xfire %s !self addoutput "targetname superdicenonvictim"'%victim)

def RandomList(args):
        if len(args) == 2:
                es.ServerVar(args[1]).set(random.choice(list(args[0])))
        else: es.dbgmsg(0,"<randomlist> You supplied more or less than 2 arguments.")

def chatcommands(userid,text,teamonly):
        if int(userid) < 2: return (userid,text,teamonly)
        else: userid = str(userid)
        text2 = text.strip('"')
        text2 = text2.lower()
	if text2 in ccommands:
                check_player(userid)
		if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 0 and roundend == 1 and int(players[userid]["roll"]) == 0:
                        rollchance = random.randint(1,100)
                        if int(es.ServerVar("superdice_rollchance")) < rollchance:
                                roll = random.choice(blocks.keys())
                                if roll in blocks:
                                        rollname = blocks[roll]["name"]
                                        es.event("initialize","superdice_roll")
                                        es.event("setint","superdice_roll","userid",userid)
                                        es.event("setstring","superdice_roll","block",roll)
                                        es.event("setstring","superdice_roll","roll",rollname)
                                        es.event("fire","superdice_roll")
                                        players[userid]["roll"] = 1
                                        if int(es.ServerVar("superdice_shout")) == 1: es.msg("#multi","\x05%s rolled %s."%(es.getplayername(userid),rollname))
                                        else: es.tell(userid,"#multi","\x05You rolled %s."%rollname)
                                        if int(es.ServerVar("superdice_rollinfo")) == 1: es.tell(userid,"#multi","\x05%s"%blocks[roll]["desc"])
                                else: es.tell(userid,"#multi","\x05Sorry, but theres been a error please roll again.")
                        else:
                                if int(es.ServerVar("superdice_rollchanceshout")) == 1: es.msg("#multi","\x05%s failed to roll anything."%es.getplayername(userid))
                                else: es.tell(userid,"#multi","\x05Sorry, you failed to roll anything.")
                                players[userid]["roll"] = 1
		else: es.tell(userid,"#multi","\x05You cannot roll right now.")
		if int(es.ServerVar("superdice_superdiceblock")) == 1: return (False,False,False)
        elif text2 in hcommands:
                superdice_help.send(userid)
                if int(es.ServerVar("superdice_superdicehelpblock")) == 1: return (False,False,False)
        return (int(userid),text,teamonly)

def round_end(ev):
	roundchange(0)
	stoprepeat()

def round_start(ev):
	gamethread.delayedname(float(es.ServerVar("superdice_rolltime")),"roundstart",roundchange,1)

def player_spawn(ev):
        if ev["es_steamid"] == "BOT": return
        check_player(ev["userid"])
        if int(players[ev["userid"]]["roll"]) == 1: players[ev["userid"]]["roll"] = 0

def superdice_roll(ev):
        es.doblock("superdice/superdiceblocks/%s"%ev["block"])
        es.playsound(ev["userid"],es.ServerVar("superdice_rollsound"),1.0)

def item_pickup(ev):
        if ev["userid"] not in players or ev["es_steamid"] == "BOT": return
        if str(players[ev["userid"]]["berserker"]).isdigit():
                if int(players[ev["userid"]]["berserker"]) == 1 and ev["item"] not in blist:
                        weapon = weaponlib.getWeapon(ev["item"])
                        if weapon is None: return
                        for index in weapon.indexlist:
                                if es.getindexprop(index,"CBaseEntity.m_hOwnerEntity") == es.getplayerhandle(ev["userid"]):
                                        es.remove(index)
                                        es.centertell(ev["userid"],"berserker restrict weapon %s is restricted"%ev["item"])
                                        break

def bullet_impact(ev):
        if ev["userid"] not in players or ev["es_userweapon"] == "weapon_knife" or ev["es_steamid"] == "BOT": return
        if str(players[ev["userid"]]["lasers"]).isdigit():
                if int(players[ev["userid"]]["lasers"]) == 1:
                        if es.getplayerteam(ev["userid"]) == 3:
                                r = 0
                                b = 255
                        else:
                                r = 255
                                b = 0
                        x,y,z = es.getplayerlocation(ev["userid"])
                        effectlib.drawLine((x,y,z + 20),(ev["x"],ev["y"],ev["z"]),halo=es.ServerVar("superdice_lasermodel"),model=es.ServerVar("superdice_lasermodel"),seconds=0.5,width=10,endwidth=10,red=r,green=50,blue=b)
                        effectlib.drawLine((x,y,z + 20),(ev["x"],ev["y"],ev["z"]),halo=es.ServerVar("superdice_lasermodel"),model=es.ServerVar("superdice_lasermodel"),seconds=0.5,width=10,endwidth=10,red=r,green=50,blue=b)
